Index: /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsTwoByte0f.cpp.h
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsTwoByte0f.cpp.h	(revision 96750)
+++ /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsTwoByte0f.cpp.h	(revision 96751)
@@ -4463,5 +4463,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -4495,5 +4495,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -4532,5 +4532,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -4564,5 +4564,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -4605,5 +4605,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -4637,5 +4637,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -4674,5 +4674,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -4706,5 +4706,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
Index: /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap1.cpp.h
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap1.cpp.h	(revision 96750)
+++ /trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap1.cpp.h	(revision 96751)
@@ -2331,5 +2331,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -2364,5 +2364,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -2402,5 +2402,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -2435,5 +2435,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -2476,5 +2476,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -2509,5 +2509,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -2547,5 +2547,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
@@ -2580,5 +2580,5 @@
             IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
         IEM_MC_ELSE()
-            IEM_MC_STORE_EFLAGS(fEFlags);
+            IEM_MC_COMMIT_EFLAGS(fEFlags);
         IEM_MC_ENDIF();
 
Index: /trunk/src/VBox/VMM/include/IEMMc.h
===================================================================
--- /trunk/src/VBox/VMM/include/IEMMc.h	(revision 96750)
+++ /trunk/src/VBox/VMM/include/IEMMc.h	(revision 96751)
@@ -314,5 +314,4 @@
 #define IEM_MC_STORE_FPUREG_R80_SRC_REF(a_iSt, a_pr80Src) \
     do { pVCpu->cpum.GstCtx.XState.x87.aRegs[a_iSt].r80 = *(a_pr80Src); } while (0)
-#define IEM_MC_STORE_EFLAGS(a_EFlags)                   pVCpu->cpum.GstCtx.eflags.u = (a_EFlags)
 
 
Index: /trunk/src/VBox/VMM/testcase/tstIEMCheckMc.cpp
===================================================================
--- /trunk/src/VBox/VMM/testcase/tstIEMCheckMc.cpp	(revision 96750)
+++ /trunk/src/VBox/VMM/testcase/tstIEMCheckMc.cpp	(revision 96751)
@@ -658,5 +658,4 @@
 #define IEM_MC_STORE_GREG_U64_CONST(a_iGReg, a_u64C)    do { AssertCompile((uint64_t)(a_u64C) == (a_u64C)); (void)fMcBegin; } while (0)
 #define IEM_MC_STORE_FPUREG_R80_SRC_REF(a_iSt, a_pr80Src) do { CHK_PTYPE(PCRTFLOAT80U, a_pr80Src); Assert((a_iSt) < 8); (void)fMcBegin; } while (0)
-#define IEM_MC_STORE_EFLAGS(a_EFlags)                   do { CHK_TYPE(uint32_t,  a_EFlags); (void)fMcBegin; } while (0)
 #define IEM_MC_CLEAR_HIGH_GREG_U64(a_iGReg)             do { (void)fMcBegin;  } while (0)
 #define IEM_MC_CLEAR_HIGH_GREG_U64_BY_REF(a_pu32Dst)    do { CHK_PTYPE(uint32_t *, a_pu32Dst); (void)fMcBegin; } while (0)