Index: trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm
===================================================================
--- trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm	(revision 96699)
+++ trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm	(revision 96918)
@@ -8364,5 +8364,5 @@
   ; disGetNextSymbol 0xc4780 LB 0x3758 -> off=0x0 cb=0000000000000034 uValue=00000000000c0000 '_msg_vga_init'
 _msg_vga_init:                               ; 0xc4780 LB 0x34
-    db  'Oracle VM VirtualBox Version 7.0.0_BETA2 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 7.0.0_BETA3 VGA BIOS', 00dh, 00ah, 000h
   ; disGetNextSymbol 0xc47b4 LB 0x3724 -> off=0x0 cb=0000000000000080 uValue=00000000000c0034 'vga_modes'
 vga_modes:                                   ; 0xc47b4 LB 0x80
@@ -9295,5 +9295,5 @@
   ; disGetNextSymbol 0xc7e5b LB 0x7d -> off=0x0 cb=0000000000000029 uValue=00000000000c36db '_vbebios_product_revision'
 _vbebios_product_revision:                   ; 0xc7e5b LB 0x29
-    db  'Oracle VM VirtualBox Version 7.0.0_BETA2', 000h
+    db  'Oracle VM VirtualBox Version 7.0.0_BETA3', 000h
   ; disGetNextSymbol 0xc7e84 LB 0x54 -> off=0x0 cb=000000000000002b uValue=00000000000c3704 '_vbebios_info_string'
 _vbebios_info_string:                        ; 0xc7e84 LB 0x2b
@@ -9309,9 +9309,11 @@
   ; Padding 0x128 bytes at 0xc7ed8
     db  001h, 000h, 000h, 000h, 000h, 001h, 000h, 000h, 000h, 000h, 000h, 000h, 02fh, 068h, 06fh, 06dh
-    db  065h, 02fh, 075h, 062h, 075h, 06eh, 074h, 075h, 02fh, 074h, 072h, 075h, 06eh, 06bh, 02fh, 06fh
-    db  075h, 074h, 02fh, 06ch, 069h, 06eh, 075h, 078h, 02eh, 061h, 06dh, 064h, 036h, 034h, 02fh, 072h
-    db  065h, 06ch, 065h, 061h, 073h, 065h, 02fh, 06fh, 062h, 06ah, 02fh, 056h, 042h, 06fh, 078h, 056h
-    db  067h, 061h, 042h, 069h, 06fh, 073h, 032h, 038h, 036h, 02fh, 056h, 042h, 06fh, 078h, 056h, 067h
-    db  061h, 042h, 069h, 06fh, 073h, 032h, 038h, 036h, 02eh, 073h, 079h, 06dh, 000h, 000h, 000h, 000h
+    db  065h, 02fh, 067h, 061h, 06ch, 069h, 074h, 073h, 079h, 06eh, 02fh, 063h, 06fh, 06dh, 070h, 069h
+    db  06ch, 065h, 02dh, 063h, 061h, 063h, 068h, 065h, 02fh, 076h, 062h, 06fh, 078h, 02dh, 063h, 06ch
+    db  065h, 061h, 06eh, 02fh, 074h, 072h, 075h, 06eh, 06bh, 02fh, 06fh, 075h, 074h, 02fh, 06ch, 069h
+    db  06eh, 075h, 078h, 02eh, 061h, 06dh, 064h, 036h, 034h, 02fh, 072h, 065h, 06ch, 065h, 061h, 073h
+    db  065h, 02fh, 06fh, 062h, 06ah, 02fh, 056h, 042h, 06fh, 078h, 056h, 067h, 061h, 042h, 069h, 06fh
+    db  073h, 032h, 038h, 036h, 02fh, 056h, 042h, 06fh, 078h, 056h, 067h, 061h, 042h, 069h, 06fh, 073h
+    db  032h, 038h, 036h, 02eh, 073h, 079h, 06dh, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
@@ -9324,5 +9326,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 05eh
+    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 03dh
Index: trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum
===================================================================
--- trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum	(revision 96699)
+++ trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum	(revision 96918)
@@ -1,1 +1,1 @@
-527c8ef97417de63598a8d8d2d3224e4 *VBoxVgaBios286.rom
+b99992b0eed0d26f49cc55e9779e8f54 *VBoxVgaBios286.rom
Index: trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm
===================================================================
--- trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm	(revision 96699)
+++ trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm	(revision 96918)
@@ -7825,5 +7825,5 @@
   ; disGetNextSymbol 0xc4780 LB 0x3758 -> off=0x0 cb=0000000000000034 uValue=00000000000c0000 '_msg_vga_init'
 _msg_vga_init:                               ; 0xc4780 LB 0x34
-    db  'Oracle VM VirtualBox Version 7.0.0_BETA2 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 7.0.0_BETA3 VGA BIOS', 00dh, 00ah, 000h
   ; disGetNextSymbol 0xc47b4 LB 0x3724 -> off=0x0 cb=0000000000000080 uValue=00000000000c0034 'vga_modes'
 vga_modes:                                   ; 0xc47b4 LB 0x80
@@ -8756,5 +8756,5 @@
   ; disGetNextSymbol 0xc7e5b LB 0x7d -> off=0x0 cb=0000000000000029 uValue=00000000000c36db '_vbebios_product_revision'
 _vbebios_product_revision:                   ; 0xc7e5b LB 0x29
-    db  'Oracle VM VirtualBox Version 7.0.0_BETA2', 000h
+    db  'Oracle VM VirtualBox Version 7.0.0_BETA3', 000h
   ; disGetNextSymbol 0xc7e84 LB 0x54 -> off=0x0 cb=000000000000002b uValue=00000000000c3704 '_vbebios_info_string'
 _vbebios_info_string:                        ; 0xc7e84 LB 0x2b
@@ -8770,9 +8770,11 @@
   ; Padding 0x128 bytes at 0xc7ed8
     db  001h, 000h, 000h, 000h, 000h, 001h, 000h, 000h, 000h, 000h, 000h, 000h, 02fh, 068h, 06fh, 06dh
-    db  065h, 02fh, 075h, 062h, 075h, 06eh, 074h, 075h, 02fh, 074h, 072h, 075h, 06eh, 06bh, 02fh, 06fh
-    db  075h, 074h, 02fh, 06ch, 069h, 06eh, 075h, 078h, 02eh, 061h, 06dh, 064h, 036h, 034h, 02fh, 072h
-    db  065h, 06ch, 065h, 061h, 073h, 065h, 02fh, 06fh, 062h, 06ah, 02fh, 056h, 042h, 06fh, 078h, 056h
-    db  067h, 061h, 042h, 069h, 06fh, 073h, 033h, 038h, 036h, 02fh, 056h, 042h, 06fh, 078h, 056h, 067h
-    db  061h, 042h, 069h, 06fh, 073h, 033h, 038h, 036h, 02eh, 073h, 079h, 06dh, 000h, 000h, 000h, 000h
+    db  065h, 02fh, 067h, 061h, 06ch, 069h, 074h, 073h, 079h, 06eh, 02fh, 063h, 06fh, 06dh, 070h, 069h
+    db  06ch, 065h, 02dh, 063h, 061h, 063h, 068h, 065h, 02fh, 076h, 062h, 06fh, 078h, 02dh, 063h, 06ch
+    db  065h, 061h, 06eh, 02fh, 074h, 072h, 075h, 06eh, 06bh, 02fh, 06fh, 075h, 074h, 02fh, 06ch, 069h
+    db  06eh, 075h, 078h, 02eh, 061h, 06dh, 064h, 036h, 034h, 02fh, 072h, 065h, 06ch, 065h, 061h, 073h
+    db  065h, 02fh, 06fh, 062h, 06ah, 02fh, 056h, 042h, 06fh, 078h, 056h, 067h, 061h, 042h, 069h, 06fh
+    db  073h, 033h, 038h, 036h, 02fh, 056h, 042h, 06fh, 078h, 056h, 067h, 061h, 042h, 069h, 06fh, 073h
+    db  033h, 038h, 036h, 02eh, 073h, 079h, 06dh, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
@@ -8785,5 +8787,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 0fdh
+    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 0dch
Index: trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum
===================================================================
--- trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum	(revision 96699)
+++ trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum	(revision 96918)
@@ -1,1 +1,1 @@
-c8b85576117f8c38d85df223caefe6d5 *VBoxVgaBios386.rom
+3bfe14eb0e51bd9c5cc46b95510d33b2 *VBoxVgaBios386.rom
Index: trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm
===================================================================
--- trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm	(revision 96699)
+++ trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm	(revision 96918)
@@ -8533,5 +8533,5 @@
   ; disGetNextSymbol 0xc4780 LB 0x3758 -> off=0x0 cb=0000000000000034 uValue=00000000000c0000 '_msg_vga_init'
 _msg_vga_init:                               ; 0xc4780 LB 0x34
-    db  'Oracle VM VirtualBox Version 7.0.0_BETA2 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 7.0.0_BETA3 VGA BIOS', 00dh, 00ah, 000h
   ; disGetNextSymbol 0xc47b4 LB 0x3724 -> off=0x0 cb=0000000000000080 uValue=00000000000c0034 'vga_modes'
 vga_modes:                                   ; 0xc47b4 LB 0x80
@@ -9464,5 +9464,5 @@
   ; disGetNextSymbol 0xc7e5b LB 0x7d -> off=0x0 cb=0000000000000029 uValue=00000000000c36db '_vbebios_product_revision'
 _vbebios_product_revision:                   ; 0xc7e5b LB 0x29
-    db  'Oracle VM VirtualBox Version 7.0.0_BETA2', 000h
+    db  'Oracle VM VirtualBox Version 7.0.0_BETA3', 000h
   ; disGetNextSymbol 0xc7e84 LB 0x54 -> off=0x0 cb=000000000000002b uValue=00000000000c3704 '_vbebios_info_string'
 _vbebios_info_string:                        ; 0xc7e84 LB 0x2b
@@ -9478,9 +9478,11 @@
   ; Padding 0x128 bytes at 0xc7ed8
     db  001h, 000h, 000h, 000h, 000h, 001h, 000h, 000h, 000h, 000h, 000h, 000h, 02fh, 068h, 06fh, 06dh
-    db  065h, 02fh, 075h, 062h, 075h, 06eh, 074h, 075h, 02fh, 074h, 072h, 075h, 06eh, 06bh, 02fh, 06fh
-    db  075h, 074h, 02fh, 06ch, 069h, 06eh, 075h, 078h, 02eh, 061h, 06dh, 064h, 036h, 034h, 02fh, 072h
-    db  065h, 06ch, 065h, 061h, 073h, 065h, 02fh, 06fh, 062h, 06ah, 02fh, 056h, 042h, 06fh, 078h, 056h
-    db  067h, 061h, 042h, 069h, 06fh, 073h, 038h, 030h, 038h, 036h, 02fh, 056h, 042h, 06fh, 078h, 056h
-    db  067h, 061h, 042h, 069h, 06fh, 073h, 038h, 030h, 038h, 036h, 02eh, 073h, 079h, 06dh, 000h, 000h
+    db  065h, 02fh, 067h, 061h, 06ch, 069h, 074h, 073h, 079h, 06eh, 02fh, 063h, 06fh, 06dh, 070h, 069h
+    db  06ch, 065h, 02dh, 063h, 061h, 063h, 068h, 065h, 02fh, 076h, 062h, 06fh, 078h, 02dh, 063h, 06ch
+    db  065h, 061h, 06eh, 02fh, 074h, 072h, 075h, 06eh, 06bh, 02fh, 06fh, 075h, 074h, 02fh, 06ch, 069h
+    db  06eh, 075h, 078h, 02eh, 061h, 06dh, 064h, 036h, 034h, 02fh, 072h, 065h, 06ch, 065h, 061h, 073h
+    db  065h, 02fh, 06fh, 062h, 06ah, 02fh, 056h, 042h, 06fh, 078h, 056h, 067h, 061h, 042h, 069h, 06fh
+    db  073h, 038h, 030h, 038h, 036h, 02fh, 056h, 042h, 06fh, 078h, 056h, 067h, 061h, 042h, 069h, 06fh
+    db  073h, 038h, 030h, 038h, 036h, 02eh, 073h, 079h, 06dh, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
@@ -9493,5 +9495,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 05ch
+    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 03bh
Index: trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum
===================================================================
--- trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum	(revision 96699)
+++ trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum	(revision 96918)
@@ -1,1 +1,1 @@
-a44d8d8dcc1e9780c149b4ab4a9c9529 *VBoxVgaBios8086.rom
+94dcfd38825dea88fa3ac9e8ef753d34 *VBoxVgaBios8086.rom